

#pragma once
//#include "atltypes.h"
//#include "afxwin.h"

class CMyLabel
{
public:
	CMyLabel(void);
	CMyLabel(CWnd* pParent);
	~CMyLabel(void);
private:
	CString m_Caption;
	COLORREF m_ColorText;
	CFont m_Font;
	CWnd* m_pParent;
	CRect m_RectRGN;
	bool m_bRGN;
	bool m_bCenter;
	int m_X;
	int m_Y;
	bool m_bShade;
	//  
	COLORREF m_ColorShade;
	long m_Width_Font;
	bool m_bVisible;

public:
	bool SetCaption(const CString& caption, const int& effect=0);
	//   
	CString GetCaption(void);

	void SetDC(CDC* pDC);
	void SetParent(CWnd* pParent);
	void Invalidate(void);

	void SetMyLabelPos(const CPoint& point, bool center=false);
	void SetMyLabelPos(const int& x, const int& y, bool center=false);
	CPoint GetMyLabelPos(void);

	void SetColorText(COLORREF color);
	COLORREF GetColorText(void)
	{
		return m_ColorText;
	}

	void SetMyLabelFont(const long& height, const long& weight, const CString& fontname, const long& width=0);
	void SetMyLabelFont(LOGFONT* logfont);
	CFont* GetMyLabelFont(void);

	void SetShade(bool shade);
	bool IsValid(void) const;
	CRect m_Rect;

	
	void Show(bool show);
	bool IsVisible(void)
	{
		return m_bVisible;
	}
};
