////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//				 
//				http://www.interestprograms.ru
//				    ,  ,  
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////



// TestMyLabelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestMyLabel.h"
#include "TestMyLabelDlg.h"
#include ".\testmylabeldlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestMyLabelDlg dialog



CTestMyLabelDlg::CTestMyLabelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestMyLabelDlg::IDD, pParent)
	, m_TextLabel_1(_T(" "))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestMyLabelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestMyLabelDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP

	ON_EN_CHANGE(IDC_EDIT_SETTEXT, OnEnChangeEditSettext)

	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_LABELFONT, OnBnClickedButtonLabelfont)
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()


// CTestMyLabelDlg message handlers

BOOL CTestMyLabelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_Label_1.SetParent(this);
	m_Label_1.SetMyLabelFont(20, 400, "Times New Roman");
	m_Label_1.SetColorText(RGB(255,255,0));
	m_Label_1.SetCaption(m_TextLabel_1);
	m_Label_1.SetShade(true);
	m_Label_1.SetMyLabelPos(10,10);
	

	m_Label_2.SetParent(this);
	m_Label_2.SetMyLabelFont(24, 400, "Times New Roman");
	m_Label_2.SetColorText(RGB(255,255,0));
	m_Label_2.SetCaption(m_TextLabel_1);
	m_Label_2.SetShade(true);
	CRect rc;
	GetClientRect(&rc);
	int x = rc.Width()/2;
	m_Label_2.SetMyLabelPos(x,100, true);
	GetDlgItem(IDC_EDIT_SETTEXT)->SetWindowText(m_TextLabel_1);
	SetTimer(2, 0, NULL);


	m_Label_3.SetParent(this);
	m_Label_3.SetMyLabelFont(28, 400, "Times New Roman");
	m_Label_3.SetColorText(RGB(255,255,0));
	m_Label_3.SetCaption("");
	m_Label_3.SetShade(true);
	m_Label_3.SetMyLabelPos(x,150, true);
	SetTimer(3, 800, NULL);

	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestMyLabelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestMyLabelDlg::OnPaint() 
{
	CRect rect;
	GetClientRect(&rect);
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); 
		//CBitmap bmp;
		//bmp.LoadBitmap(IDB_BITMAP1);
		//dc.DrawState(CPoint(0,0), CSize(rect.Width(), rect.Height()), &bmp, DST_BITMAP);
		//bmp.LoadBitmap(IDB_BITMAP2);
		//CBrush brush(&bmp);
		//CBrush* poldBrush = dc.SelectObject(&brush);
		//dc.Rectangle(&rect);
		//dc.SelectObject(poldBrush);

		m_Label_1.SetDC(&dc);
		m_Label_2.SetDC(&dc);
		m_Label_3.SetDC(&dc);
		
		//CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestMyLabelDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestMyLabelDlg::OnEnChangeEditSettext()
{
	GetDlgItem(IDC_EDIT_SETTEXT)->GetWindowText(m_TextLabel_1);
	m_Label_1.SetCaption(m_TextLabel_1);

	m_Label_2.SetCaption(m_TextLabel_1);
	
}


void CTestMyLabelDlg::OnClose()
{
	KillTimer(2);
	KillTimer(3);

	CDialog::OnClose();
}

void CTestMyLabelDlg::OnBnClickedButtonLabelfont()
{
	LOGFONT logfont;
	memset(&logfont, 0, sizeof(LOGFONT));
	m_Label_1.GetMyLabelFont()->GetLogFont(&logfont);
	CFontDialog dlg(&logfont);
	dlg.m_cf.lStructSize = sizeof(CHOOSEFONT);
	dlg.m_cf.rgbColors = m_Label_1.GetColorText();
	
	if(dlg.DoModal() == IDOK)
	{
		dlg.GetCurrentFont(&logfont);
		m_Label_1.SetMyLabelFont(&logfont);
		m_Label_2.SetMyLabelFont(&logfont);
		//m_Label_3.SetMyLabelFont(&logfont);

		COLORREF color = dlg.GetColor();
		m_Label_1.SetColorText(color);
		m_Label_2.SetColorText(color);
		//m_Label_3.SetColorText(color);
	}
}

BOOL CTestMyLabelDlg::OnEraseBkgnd(CDC* pDC)
{
	CRect rect;
	GetClientRect(&rect);
	CBitmap bmp;
	bmp.LoadBitmap(IDB_BITMAP3);
	CBrush brush(&bmp);
	CBrush* poldBrush = pDC->SelectObject(&brush);
	pDC->Rectangle(&rect);
	pDC->SelectObject(poldBrush);

	return TRUE; //CDialog::OnEraseBkgnd(pDC);
}

void CTestMyLabelDlg::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	CRect rc;
	GetClientRect(&rc);
	if(nIDEvent == 2)
	{
		static x = 0;
		m_Label_1.SetMyLabelPos(x, 10);
		x -= 1;

		if( m_Label_1.GetMyLabelPos().x < (-m_Label_1.m_Rect.Width()) )
			x = rc.Width();
	}

	if(nIDEvent == 3)
	{
		static count_effect = 1;
		KillTimer(3);

		CString s[8] = {"", "", "", "", 
						"", "", "", "  !"};
		static int count = 1;
		if(m_Label_3.SetCaption(s[count], count_effect) == true)
		{
			count++;
			if(count == 8)
			{
				count = 0;
				count_effect++;
				if(count_effect == 5)
					count_effect = 0;
			}

			SetTimer(3, 800, NULL);
		}
		
	}



	CDialog::OnTimer(nIDEvent);
}


void CTestMyLabelDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if(m_Label_2.IsValid() == true)
	{
		m_Label_2.SetMyLabelPos(cx/2, 100, true);
		Invalidate();
	}

	if(m_Label_3.IsValid() == true)
	{
		m_Label_3.SetMyLabelPos(cx/2, 150, true);
		Invalidate();
	}
}

void CTestMyLabelDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	lpMMI->ptMaxTrackSize.x = 480;
	lpMMI->ptMaxTrackSize.y = 340;

	CDialog::OnGetMinMaxInfo(lpMMI);
}


